#ifndef _ISLIST_HPP_
#define _ISLIST_HPP_
#include <stddef.h>

class ISList;

class INode
{
 public:
  size_t basicLine;
  size_t line;
  INode(size_t bl, size_t l, INode *n = 0)
  {
   basicLine = bl; line = l;
   next = n;
  }

  INode *next;
  friend ISList;
};

class ISList
{
 private:
  INode *head;
  INode *tail;
  size_t noNodes;
  void remove(void)
  {
   if(!noNodes) return;
   INode *cur = head, *next;
   while(cur)
   {
    next = cur->next;
    delete cur;
    cur = next;
   }
  }
 public:
  ISList(void)
  {
   head = tail = 0;
   noNodes = 0;
  }
  ~ISList(void);

  void add(size_t bl, size_t l);
  
  void removeAll(void);

  size_t operator[](size_t bl);
  size_t operator()(size_t bl);
};

ISList::~ISList(void) { remove(); }

void ISList::removeAll(void)
{
 remove();
 noNodes = 0;
 head = tail = 0;
}

void ISList::add(size_t bl, size_t l)
{
 if(!noNodes)
  head = tail = new INode(bl, l);
 else
 {
  INode *cur = head, *prev = 0;
  while(cur)
  {
   if(cur->basicLine >= bl) break;
   prev = cur;
   cur = cur->next;
  }
  if(!prev)
   head = new INode(bl, l, head);
  else
   prev->next = new INode(bl, l, cur);
 }
 noNodes++;
}
//  襣  ࠢ 祭
size_t ISList::operator[](size_t bl)
{
 INode *cur = head;
 for(int i = 0; i < noNodes; i++)
 {
  if(cur->basicLine >= bl) return cur->line;
  cur = cur->next;
 }
 return 0;
}

//  襣  ࠢ 祭
size_t ISList::operator()(size_t bl)
{
 INode *cur = head;
 size_t tmp = cur->line;
 for(int i = 0; i < noNodes; i++)
 {
  if(cur->basicLine == bl) return cur->line;
  if(cur->basicLine > bl)  return tmp;
  tmp = cur->line;
  cur = cur->next;
 }
 return 0;
}

#endif