#ifndef __BVIEW_H__
#define __BVIEW_H__
#include "common.hpp"
#include <conio.h>

struct FileId
{
 char name[8];
 char type;
 u16 start;
 u16 length;
};

struct HoHdr
{
 FileId file;
 u8 reserved;
 u8 noSex;
 u16 checkSum;
};

/*
 *  type = 1 - ⮪     ப
 *  type = 0 - ⮪      ப
 */
struct Token
{
 char name[11];
 u8 type;
};

Token tokenTable[] = {
 {"RND ", 0 },   {"INKEY$", 0},   {"PI", 0},      {"FN ", 0},     {"POINT ", 1},
 {"SCREEN$", 0}, {"ATTR ", 0},    {"AT ", 0},     {"TAB", 0},     {"VAL$ ", 0},
 {" CODE ", 0},  {"VAL ", 0},     {"LEN ", 0},    {"SIN ", 0},    {"COS ", 0},
 {"TAN ", 0},    {"ASN ", 0},     {"ACS ", 0},    {"ATN ", 0},    {"LN ", 0},
 {"EXP ", 0},    {"INT ", 0},     {"SQR ", 0},    {"SGN ", 0},    {"ABS ", 0},
 {"PEEK ", 0},   {"IN ", 0},      {"USR ", 0},    {"STR$ ", 0},   {"CHR$ ", 0},
 {"NOT ", 0},    {"BIN ", 0},     {" OR ", 0},    {" AND ", 0},   {"<=", 0},
 {">=", 0},      {"<>", 0},       {"LINE ", 0},   {" THEN ", 0},  {" TO ", 0},
 {" STEP ", 0},  {"DEF FN ", 1},  {"CAT", 1},     {"FORMAT ", 1}, {"MOVE ", 1},
 {"ERASE ", 1},  {"OPEN# ", 1},   {"CLOSE# ", 1}, {"MERGE ", 1},  {"VERIFY ", 1},
 {"BEEP ", 1},   {"CIRCLE ", 1},  {"INK ", 2},    {"PAPER ", 2},  {"FLASH ", 2},
 {"BRIGHT ", 2}, {"INVERSE ", 2}, {"OVER ", 2},   {"OUT ", 1},    {"LPRINT ", 1},
 {"LLIST ", 1},  {"STOP", 1},     {"READ ", 1},   {"DATA ", 1},   {"RESTORE ", 1},
 {"NEW", 1},     {"BORDER ", 1},  {"CONTINUE", 1},{"DIM ", 1},    {"REM ", 1},
 {"FOR ", 1},    {"GO TO ", 1},   {"GO SUB ", 1}, {"INPUT ", 1},  {"LOAD ", 1},
 {"LIST ", 1},   {"LET ", 1},     {"PAUSE ", 1},  {"NEXT ", 1},   {"POKE ", 1},
 {"PRINT ", 1},  {"PLOT ", 1},    {"RUN ", 1},    {"SAVE ", 1},   {"RANDOMIZE ", 1},
 {"IF ", 1},     {"CLS", 1},      {"DRAW ", 1},   {"CLEAR ", 1},  {"RETURN", 1},
 {"COPY ", 1} };

const int noTokens = sizeof(tokenTable)/sizeof(Token);
int tokenSize[noTokens];

char CtrlCharTable1[][4] = { "AT", "TAB" };
char CtrlCharTable2[][8] = { "INK", "PAPER", "FLASH", "BRIGHT", "INVERSE", "OVER" };

// 
enum {unknownColor = 0, defaultColor, tokenColor, commentColor, numberColor, lineNumberColor, ctrlCodesColor, keyColor, txtColor, sbColor, helpColor, winColor, inputColor};
u8 colors[12];

u8 keyBar[] = {keyColor,
               '1', txtColor, 'H', 'e', 'l', 'p', ' ', ' ', keyColor, ' ',
               '2', txtColor, 'S', 'a', 'v', 'e', 'A', 's', keyColor, ' ',
               '3', txtColor, 'C', 't', 'r', 'l', 'C', 'd', keyColor, ' ',
               '4', txtColor, 'R', 'l', 'N', 'u', 'm', ' ', keyColor, ' ',
               '5', txtColor, 'G', 'o', 'T', 'o', ' ', ' ', keyColor, ' ',
               '6', txtColor, ' ', ' ', ' ', ' ', ' ', ' ', keyColor, ' ',
               '7', txtColor, ' ', ' ', ' ', ' ', ' ', ' ', keyColor, ' ',
               '8', txtColor, 'S', 'h', 'R', 'E', 'M', ' ', keyColor, ' ',
               '9', txtColor, ' ', ' ', ' ', ' ', ' ', ' ', keyColor, ' ',
               '1', '0', txtColor, 'Q', 'u', 'i', 't', ' ', ' ', 0 };
#endif